{
   Copyright (C) 2010 MegaBrutal

   This unit is free software: you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This unit is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


{$MODE DELPHI}
unit EINIFiles;

interface
uses SysUtils, INIFiles;

type

   TExtBoolINIFile = class(TINIFile)
   public
      function ReadBool(const Section, Ident: string; Default: boolean): boolean; override;
   end;



implementation


function TExtBoolINIFile.ReadBool(const Section, Ident: string; Default: boolean): boolean;
var Value: string; DefValStr: shortstring;
begin
   if Default then DefValStr:= 'ON' else DefValStr:= 'OFF';
   Value:= UpperCase(ReadString(Section, Ident, DefValStr));
   if Value = 'ON' then        Result:= true
   else if Value = 'OFF' then  Result:= false
   else                        Result:= inherited ReadBool(Section, Ident, Default);
end;


end.