{
   Copyright (C) 2010 MegaBrutal

   This unit is free software: you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This unit is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


{$MODE DELPHI}

unit SocketUtils;

interface
uses Sockets;

type

   socket = longint;


   function SockReadLn(Sock: socket; var Line: string): boolean;
   function SockWriteLn(Sock: socket; const Line: string): boolean;



implementation


function SockReadLn(Sock: socket; var Line: string): boolean;
var recvb: longint; ch: char;
begin
   Line:= '';
   repeat
      recvb:= fpRecv(Sock, @ch, 1, 0);
      if (recvb = 1) and ((ch <> #13) and (ch <> #10)) then
         Line:= Line + ch;
   until (recvb <> 1) or (ch = #10);
   Result:= (recvb = 1);
end;

function SockWriteLn(Sock: socket; const Line: string): boolean;
begin
   Result:= fpSend(Sock, PChar(Line + #13#10), Length(Line) + 2, 0) <> -1;
end;


end.
